## propellor 5.3.3

=== Makefile ===
CABAL?=cabal
DATE := $(shell dpkg-parsechangelog 2>/dev/null | grep Date | cut -d " " -f2-)

build: tags propellor.1 dist/setup-config
	$(CABAL) build
	ln -sf dist/build/propellor-config/propellor-config propellor

install:
	install -d $(DESTDIR)/usr/bin $(DESTDIR)/usr/src/propellor
	install -s dist/build/propellor/propellor $(DESTDIR)/usr/bin/propellor
	mkdir -p dist/gittmp
	$(CABAL) sdist
	cat dist/propellor-*.tar.gz | (cd dist/gittmp && tar zx --strip-components=1)
	# cabal sdist does not preserve symlinks, so copy over file
	cd dist/gittmp && for f in $$(find -type f); do rm -f $$f; cp -a ../../$$f $$f; done
	# reset mtime on files in git bundle so bundle is reproducible
	find dist/gittmp -print0 | xargs -0r touch --no-dereference --date="$(DATE)"
	export GIT_AUTHOR_NAME=build \
	&& export GIT_AUTHOR_EMAIL=build@buildhost \
	&& export GIT_AUTHOR_DATE="$(DATE)" \
	&& export GIT_COMMITTER_NAME=build \
	&& export GIT_COMMITTER_EMAIL=build@buildhost \
	&& export GIT_COMMITTER_DATE="$(DATE)" \
	&& cd dist/gittmp && git init \
	&& git add . \
	&& git commit -q -m "distributed version of propellor" \
	&& git bundle create $(DESTDIR)/usr/src/propellor/propellor.git master HEAD \
	&& git show-ref master --hash > $(DESTDIR)/usr/src/propellor/head
	rm -rf dist/gittmp

clean:
	rm -rf dist Setup tags propellor propellor.1 privdata/local
	find -name \*.o -exec rm {} \;
	find -name \*.hi -exec rm {} \;

# hothasktags chokes on some template haskell etc, so ignore errors
# duplicate tags with Propellor.Property. removed from the start, as we
# often import qualified by just the module base name.
tags:
	find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$' | xargs hothasktags 2>/dev/null | perl -ne 'print; s/Propellor\.Property\.//; print' | sort > tags || true

dist/setup-config: propellor.cabal
	@if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
	@$(CABAL) configure

propellor.1: doc/usage.mdwn doc/mdwn2man
	doc/mdwn2man propellor 1 < doc/usage.mdwn > propellor.1

.PHONY: tags

=== debian/changelog ===
propellor (5.3.3-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 26 Feb 2018 14:46:09 -0700

propellor (5.3.3) unstable; urgency=medium

  * Warn again about new upstream version when ~/.propellor was cloned from the
    Debian git bundle using an older version of propellor that set up an
    upstream remote.
  * Avoid crashing if initial fetch from origin fails when spinning a host.
  * Added Propllor.Property.Openssl module contributed by contributed by
    Félix Sipma.

 -- Joey Hess <id@joeyh.name>  Mon, 26 Feb 2018 14:34:37 -0400

propellor (5.3.2-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 18 Feb 2018 14:34:00 -0700

propellor (5.3.2) unstable; urgency=medium

  * Added Propellor.Property.Atomic, which can make a non-atomic property
    that operates on a directory into an atomic property.
    (Inspired by Vaibhav Sagar's talk on Functional Devops in a
    Dysfunctional World at LCA 2018.)
  * Added Git.pulled.
  * Systemd.machined: Install systemd-container on Debian
    stretch.
    Thanks, Sean Whitton

 -- Joey Hess <id@joeyh.name>  Sun, 18 Feb 2018 14:31:39 -0400

propellor (5.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 05 Feb 2018 21:27:41 -0700

propellor (5.3.1) unstable; urgency=medium

  * Last release mistakenly contained my personal branch not master.
  * contrib/post-merge-hook documentation updated to recommend also using
    it as a post-checkout hook, to avoid such problems.

 -- Joey Hess <id@joeyh.name>  Sun, 04 Feb 2018 12:00:03 -0400

propellor (5.3.0) unstable; urgency=medium

  * Avoid bogus warning about new upstream version when /usr/bin/propellor
    is run on a Debian system, but ~/.propellor was not cloned from the
    Debian git bundle.
  * Parted: Allow partitions to have no filesystem, for eg, GPT BIOS boot
    partitions. (API change)
  * Added rawPartition to PartSpec, for specifying partitions with no
    filesystem.
  * Added BiosGrubFlag to PartFlag.
  * Add HasCallStack constraint to pickOS and unsupportedOS, so the
    call stack includes the caller.
  * Run su with --login, to avoid inheriting some problematic environment
    variables, such as TMP, from the caller.
  * Grub: Added properties to configure /etc/default/grub.
  * Laptop: New module, starting with powertopAutoTuneOnBoot.

 -- Joey Hess <id@joeyh.name>  Thu, 01 Feb 2018 12:27:01 -0400

propellor (5.2.0-1) unstable; urgency=medium

  * Package new upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 02 Jan 2018 11:06:08 +0000

propellor (5.2.0) unstable; urgency=medium

  [ Joey Hess ]
  * bootstrappedFrom: Set up local privdata file.
  * Parted: Fix names used for FAT and VFAT partitions.
  * Parted: Add an Alignment parameter. (API change)
    A good default to use is safeAlignment, which is 4MiB,
    well suited for inexpensive flash drives, and fine for other disks too.
    Previously, a very non-optimial 1MB (not 1MiB) alignment had been used.
  * DiskImage: Use safeAlignment. It didn't seem worth making the
    alignment configurable here.
  * Fixed rounding bug in Parted.calcPartTable.
  * DiskImage: Fix rsync crash when a mount point does not exist in the
    chroot.
  * Fix bug in unmountBelow that caused unmounting of nested mounts to
    fail.
  * Grub.boots, Grub.bootsMounted: Pass --target to grub-install.
  * Added Propellor.Property.Installer modules, which can be used to create
    bootable installer disk images, which then run propellor to install
    a system. This code was extracted from the demo I gave in my
    talk at DebConf 2017.

  [ Sean Whitton ]
  * Sbuild: add notes about Debian jessie hosts and backports of sbuild and
    autopkgtest.

 -- Joey Hess <id@joeyh.name>  Sat, 30 Dec 2017 13:34:29 -0400

propellor (5.1.0-1) unstable; urgency=medium

  * Package new upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 23 Nov 2017 14:49:17 -0700

propellor (5.1.0) unstable; urgency=medium

  [ Sean Whitton ]
  * File.isSymlinkedTo now revertable. (minor API change)
  * Sbuild module changes:
    - Type of Sbuild.built changed to accept additional properties to be
      ensured inside schroots. (API change)
      See the suggested usage in module's documentation for new syntax.
    - Drop Sbuild.installed, Sbuild.builtFor, Sbuild.updated,
      Sbuild.updatedFor. (API change)
      Use Sbuild.built instead.  See suggested usage in module's documentation.
    - Propellor no longer sets up apt proxies in sbuild chroots automatically.
      Instead, pass the new Sbuild.useHostProxy to Sbuild.built to have
      Propellor propagate the host's Apt proxy configuration into the chroot.
      See suggested usage in module's documentation.
    - Internally, Propellor no longer invokes sbuild-createchroot(1) to build
      schroots.
    - Update documentation.

 -- Joey Hess <id@joeyh.name>  Thu, 23 Nov 2017 10:38:16 -0400

propellor (5.0.0) unstable; urgency=medium

  * Debootstrap.built now supports bootstrapping chroots for foreign
    OS's, using qemu-user-static.
  * Machine: New module collecting machine-specific properties for 
    building bootable images for ARM boards.
    Tested working boards: Olimex Lime, CubieTruck, Banana Pi, SheevaPlug.
  * Diskimage.imageBuiltFor: New property to build a disk image for a Host,
    using partition table information configured via the new properties
    hasPartitionTableType, hasPartition and adjustPartition.
  * Chroot.noServices moved to Service.noServices and its type changed.
    (API change)
  * Service: Avoid starting services when noServices is used.
  * Add Typeable instance to OriginUrl, fixing build with old versions
    of ghc.
  * Added Propellor.Property.impossible
  * Fail2Ban: Added several additional properties.
    Thanks, Félix Sipma.
  * Fail2Ban: Renamed jail.d conf file to use .local.


=== debian/control ===
Source: propellor
Section: admin
Priority: optional
Build-Depends:
 cabal-install,
 cdbs,
 debhelper (>= 10),
 ghc (>= 7.6),
 git,
 haskell-devscripts,
 libghc-ansi-terminal-dev,
 libghc-ansi-terminal-prof,
 libghc-async-dev,
 libghc-async-prof,
 libghc-exceptions-dev (>= 0.6),
 libghc-exceptions-prof (>= 0.6),
 libghc-hashable-dev,
 libghc-hashable-prof,
 libghc-hslogger-dev,
 libghc-hslogger-prof,
 libghc-ifelse-dev,
 libghc-ifelse-prof,
 libghc-mtl-dev,
 libghc-mtl-prof,
 libghc-network-dev,
 libghc-network-prof,
 libghc-split-dev,
 libghc-split-prof,
 libghc-stm-dev,
 libghc-stm-prof,
 libghc-text-dev,
 libghc-text-prof,
 libghc-transformers-dev,
 libghc-transformers-prof,
 libghc-unix-compat-dev,
 libghc-unix-compat-prof,
Maintainer: Sean Whitton <spwhitton@spwhitton.name>
Standards-Version: 4.1.0
Homepage: https://propellor.branchable.com/
Vcs-Git: https://git.spwhitton.name/propellor -b debian
Vcs-Browser: https://git.spwhitton.name/propellor
X-Description: property-based host configuration management in haskell
 Propellor ensures that the system it's run in satisfies a list of
 properties, taking action as necessary when a property is not yet met.
 .
 It is configured using haskell.
 .
 The easiest way to get started with propellor is to install the binary package
 `propellor' and run `propellor --init'.

Package: libghc-propellor-dev
Section: haskell
Architecture: any
Depends:
 ${haskell:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ${haskell:Recommends},
Suggests:
 ${haskell:Suggests},
Conflicts:
 ${haskell:Conflicts},
Provides:
 ${haskell:Provides},
Description: ${haskell:ShortDescription}${haskell:ShortBlurb}
 ${haskell:LongDescription}
 .
 ${haskell:Blurb}

Package: libghc-propellor-doc
Architecture: all
Section: doc
Depends:
 ${haskell:Depends},
 ${misc:Depends},
Recommends:
 ${haskell:Recommends},
Suggests:
 ${haskell:Suggests},
Conflicts:
 ${haskell:Conflicts},
Description: ${haskell:ShortDescription}${haskell:ShortBlurb}
 ${haskell:LongDescription}
 .
 ${haskell:Blurb}

Package: libghc-propellor-prof
Section: haskell
Architecture: any
Depends:
 ${haskell:Depends},
 ${misc:Depends},
Recommends:
 ${haskell:Recommends},
Suggests:
 ${haskell:Suggests},
Conflicts:
 ${haskell:Conflicts},
Provides:
 ${haskell:Provides},
Description: ${haskell:ShortDescription}${haskell:ShortBlurb}
 ${haskell:LongDescription}
 .
 ${haskell:Blurb}

Package: propellor
Architecture: any
Depends:
 cabal-install,
 ghc (>= 7.4),
 git (>= 1:2.9),
 libghc-ansi-terminal-dev,
 libghc-async-dev,
 libghc-exceptions-dev (>= 0.6),
 libghc-hashable-dev,
 libghc-hslogger-dev,
 libghc-ifelse-dev,
 libghc-mtl-dev,
 libghc-network-dev,
 libghc-propellor-dev,
 libghc-split-dev,
 libghc-stm-dev,
 libghc-text-dev,
 libghc-transformers-dev,
 libghc-unix-compat-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: property-based host configuration management in haskell
 Propellor ensures that the system it's run in satisfies a list of
 properties, taking action as necessary when a property is not yet met.
 .
 It is configured using haskell.

## propellor 5.4.1

=== debian/changelog ===
propellor (5.4.1-1) unstable; urgency=medium

  * New upstream release.
    - Tighten build-dep on git to require 2.0.
  * Drop Recommends: from libghc-propellor-doc.  See #905892.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 11 Aug 2018 11:22:52 +0100

propellor (5.4.1) unstable; urgency=medium

  * Modernized and simplified the MetaTypes implementation now that
    compatability with ghc 7 is no longer needed.
  * Use git verify-commit to verify gpg signatures, rather than the old
    method of parsing git log output. Needs git 2.0.
  * Added ConfFile.containsShellSetting, ConfFile.lacksShellSetting,
    and EtcDefault.set properties. Thanks, Sean Whitton
  * Dns: Support TXT values longer than bind's maximum string length
    of 255 bytes. Thanks, rsiddharth.
  * Docker and HostingProvider.CloudAtCost modules are not being
    maintained, so marked them as such.
    Seeking a maintainer for the Docker module; I anticipate
    removing the CloudAtCost module in the next API bump.

 -- Joey Hess <id@joeyh.name>  Wed, 08 Aug 2018 10:29:27 -0400

propellor (5.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 12 Jul 2018 09:27:16 +0100

propellor (5.4.0) unstable; urgency=medium

  [ Sean Whitton ]
  * Apt.installedBackport replaced with Apt.backportInstalled.  (API change)
    The old property would install dependencies from backports even when
    the versions in stable satisfy the requested backport's dependencies.
    The new property installs only the listed packages from backports;
    all other dependencies come from stable.
    So in some cases, you may need to list additional backports to install,
    that would not have needed to be listed before. Due to this behavior
    change the property has been renamed so uses of it will be checked.
  * Restic.installed: stop trying to install a backport on jessie, because no
    such backport exists.

 -- Joey Hess <id@joeyh.name>  Thu, 17 May 2018 10:43:20 -0400

propellor (5.3.6-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 13 May 2018 15:33:42 -0700

propellor (5.3.6) unstable; urgency=medium

  * Fix build with ghc 8.4, which broke due to the Semigroup Monoid change.
  * Dropped support for building propellor with ghc 7 (as in debian
    oldstable), to avoid needing to depend on the semigroups transitional
    package, but also because it's just too old to be worth supporting.
  * stack.yaml: Updated to lts-9.21.
  * Make Schroot.overlaysInTmpfs revertable
    Thanks, Sean Whitton
  * Update shim each time propellor is run in a container, to deal with
    library version changes.
  * Unbound: Added support for various DNS record types.
    Thanks, Félix Sipma.

 -- Joey Hess <id@joeyh.name>  Wed, 09 May 2018 16:24:37 -0400

propellor (5.3.5-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 28 Apr 2018 13:03:55 -0700

propellor (5.3.5) unstable; urgency=medium

  * Apt.stdSourcesList now adds stable-updates suite
    Thanks, Sean Whitton
  * Significantly increased propellor build speed when your config.hs
    is in a fork of the propellor repository, by avoiding redundant builds
    of propellor library.

 -- Joey Hess <id@joeyh.name>  Sun, 22 Apr 2018 12:27:45 -0400

propellor (5.3.4-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 29 Mar 2018 10:25:50 -0700

propellor (5.3.4) unstable; urgency=medium

  * Apt.trustsKey: Use apt-key to add key rather than manually driving gpg,
    which seems to not work anymore.
    Thanks, Russell Sim.
  * Firewall: Reorder iptables parameters that are order
    dependant to make --to-dest and --to-source work.
    Thanks, Russell Sim

 -- Joey Hess <id@joeyh.name>  Wed, 21 Mar 2018 14:59:15 -0400

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  cdbs,
  debhelper (>= 10),
  ghc (>= 7.6),
- git,
+ git (>= 1:2.0),
  haskell-devscripts,
  libghc-ansi-terminal-dev,
  libghc-ansi-terminal-prof,
@@ -74,8 +74,6 @@
 Depends:
  ${haskell:Depends},
  ${misc:Depends},
-Recommends:
- ${haskell:Recommends},
 Suggests:
  ${haskell:Suggests},
 Conflicts:

## propellor 5.6.0

=== debian/changelog ===
propellor (5.6.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop cherry picked patch.
    Included in this release.
  * Patch Libvirt.hs to fix Haddock build.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 20 Jan 2019 15:25:47 -0700

propellor (5.6.0) unstable; urgency=medium

  * withOS had a type level bug that allowed ensureProperty to be used inside
    it with a Property that does not match the type of the withOS itself.
    (API change)
    The fix may cause some of your valid uses of withOS to no longer type
    check; the best way to work around that is to use pickOS to pick between
    several properties that are further specialized using withOS.
    For an example of how to do that, see the source code to
    Propellor.Property.Borg.installed
  * Propellor.Property.Cron.runPropellor is a Property DebianLike; it was
    incorrectly a Property UnixLike before and that wrong type was hidden by
    the withOS bug.
  * Some openbsd portability fixes. Thanks, rsiddharth.
  * Added Libvirt module. Thanks, Sean Whitton.
  * When bootstrapping on Debian, libghc-stm-dev may not be available,
    as it's become part of ghc, so check before trying to install it.
  * Fix build with ghc 8.6.3.
  * Avoid exposing the constructor of OuterMetaTypesWitness, to avoid
    the kind of mistake that led to the withOS bug.
  * Merged Utility changes from git-annex.
  * Fix --spin crash when ~/.ssh/ directory did not already exist.

 -- Joey Hess <id@joeyh.name>  Fri, 18 Jan 2019 12:11:53 -0400

propellor (5.5.0-2) unstable; urgency=medium

  * Cherry pick upstream commit d2a526833f7178a04b00704890cf6ee8c1187618
    - Drop build-dep on haskell-stm.
    - Build-dep on ghc (>= 8.4.3), with which haskell-stm is now bundled
    - In Bootstrap, still try to install haskell-stm, but suppress error from
      apt if not installable.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 04 Dec 2018 21:34:10 -0700

propellor (5.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 20 Oct 2018 18:42:33 -0700

propellor (5.5.0) unstable; urgency=medium

  * letsencrypt': Pass --expand to support expanding the list of domains
  * Split mailname property out of Hostname.sane, since bad mailname
    guesses can lead to ugly surprises. (API change)
  * Removed HostingProvider.CloudatCost module as it lacks a maintainer.
    (If anyone would like to maintain it, send a patch adding it back.)
    (API change)
  * Added Systemd.escapePath helper function useful when creating mount
    units.
  * Added Sudo.sudoersDFile property.
  * Sudo.enabledFor: Write to /etc/sudoers.d/000users rather than to
    /etc/sudoers. (Any old lines it wrote to /etc/sudoers will be removed.)
    This fixes a potential ordering problem; the property used to append
    the line to /etc/sudoers, but that would override more specific lines
    in the include directory.
  * Borg: Added UsesEnvVar.
  * Added DiskImage.noBootloader, useful for eg, direct booting with
    qemu. Thanks, David Bremner.
  * Added Apt.backportInstalledMin.

 -- Joey Hess <id@joeyh.name>  Sat, 20 Oct 2018 21:00:27 -0400

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
  cabal-install,
  cdbs,
  debhelper (>= 10),
- ghc (>= 7.6),
+ ghc (>= 8.4.3),
  git (>= 1:2.0),
  haskell-devscripts,
  libghc-ansi-terminal-dev,
@@ -26,8 +26,6 @@
  libghc-network-prof,
  libghc-split-dev,
  libghc-split-prof,
- libghc-stm-dev,
- libghc-stm-prof,
  libghc-text-dev,
  libghc-text-prof,
  libghc-transformers-dev,
@@ -106,7 +104,7 @@
 Architecture: any
 Depends:
  cabal-install,
- ghc (>= 7.4),
+ ghc (>= 8.4.3),
  git (>= 1:2.9),
  libghc-ansi-terminal-dev,
  libghc-async-dev,
@@ -118,7 +116,6 @@
  libghc-network-dev,
  libghc-propellor-dev,
  libghc-split-dev,
- libghc-stm-dev,
  libghc-text-dev,
  libghc-transformers-dev,
  libghc-unix-compat-dev,

=== debian/rules ===
#!/usr/bin/make -f

# don't install CHANGELOG as it duplicates d/changelog
DEB_INSTALL_CHANGELOGS_ALL=-XCHANGELOG

# Avoid using cabal, as it writes to $HOME
export CABAL=./Setup

build/propellor::
	$(MAKE) build
install/propellor::
	DESTDIR=$(CURDIR)/debian/propellor $(MAKE) install

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk

## propellor 5.9.1

=== debian/changelog ===
propellor (5.9.1-1) unstable; urgency=medium

  * New upstream release.
  * Add {build-,}dep on libghc-type-errors-dev.
  * Drop fix-libvirt.hs-haddock-build.patch.
    Applied upstream.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 13 Sep 2019 13:23:43 -0700

propellor (5.9.1) unstable; urgency=medium

  * Apt: Debian has changed the name of the suite for testing security updates
    from testing to testing-security.
  * Apt: Also the suite for stable releases from bullseye on will be
    suffixed with "-security".
  * Apt.update: Pass --allow-releaseinfo-change when updating Unstable
    or Testing, so that code name changes that happen in those suites
    during a stable release don't prevent updating the rolling suites.
  * Systemd.machined: Fix a bug that caused the systemd-container package
    to not be installed when used with Debian buster.

 -- Joey Hess <id@joeyh.name>  Wed, 17 Jul 2019 15:59:29 -0400

propellor (5.9.0) unstable; urgency=medium

  * Added custom type error messages when Properties don't combine due to
    conflicting MetaTypes.
  * Added custom type error messages for ensureProperty and tightenTargets.
  * Note that those changes made ghc 8.0.1 in a few cases unable to infer
    types when ensureProperty or tightenTargets is used, while later ghc
    versions had no difficulty. If this affects building your properties,
    adding a type annotation to the code will work around the problem.
  * Added custom type error messages displayed when type inference
    fails when using ensureProperty and tightenTargets, that suggest
    adding a type annotation.
  * Use the type-errors library to detect when the type checker gets stuck
    unable to reduce type-level operations on MetaTypes, and avoid 
    displaying massive error messages.
  * But, since type-errors is a new library not available in eg Debian
    yet, added a WithTypeErrors build flag. When the library is not
    available, cabal will automatically disable that build flag,
    and it will build without the type-errors library.
  * EnsurePropertyAllowed, TightenTargetsAllowed, and CheckCombinable
    types have changed to Constraint.
    (API change)
  * Try harder to avoid displaying an excessive amount of type error
    messages when many properties have been combined in a props list.
  * Libvirt.installed: install libvirt-daemon-system
    Thanks, David Bremner

 -- Joey Hess <id@joeyh.name>  Tue, 02 Jul 2019 16:27:07 -0400

propellor (5.8.0) unstable; urgency=medium

  * Fix bug in File.containsShellSetting that replaced whole shell conffile
    content with the setting if the file did not previously contain a line
    setting the key to some value.
  * Removed inChroot, instead use hasContainerCapability FilesystemContained.
    (API change)
  * Hostname: Properties that used to not do anything in a systemd or
    docker container will now change the container's hostname,
    since it's namespaced.
  * Add User.ownsWithPrimaryGroup
    Thanks, Sean Whitton
  * Ssh.userKeys, Ssh.userKeyAt: Create .ssh directory when it does not yet
    exist.
  * Ssh.userKeyAt: When a relative filepath is provided, it's put inside
    the user's .ssh directory.
  * Fix Git.pulled always reporting a change.
    Thanks, Sean Whitton

 -- Joey Hess <id@joeyh.name>  Fri, 26 Apr 2019 08:23:29 -0400

propellor (5.7.0) unstable; urgency=medium

  * Sbuild.built no longer includes Apt.stdSourcesList by default,
    in order to support non-Debian OS's. (API change)
    To upgrade: Simply add Sbuild.osDebianStandard to all Sbuild.built
    calls which have osDebian.
    Thanks, Sean Whitton
  * Propellor.Property.PropellorRepo renamed to Propellor.Property.Localdir
    to widen its scope. (API change)
  * Added Localdir.removed property.
    Thanks, Sean Whitton
  * Sbuild.built uses Localdir.removed to clean up the propellor localdir
    after it's done running in a schroot.
    Thanks, Sean Whitton
  * Cron.runPropellor made revertable. (minor API change)
    Thanks, Sean Whitton
  * Added Cron.jobDropped.
    Thanks, Sean Whitton
  * Added Utility.FileMode to the modules exported by Propellor.Utilities
    to propellor library users.

 -- Joey Hess <id@joeyh.name>  Fri, 05 Apr 2019 11:59:52 -0400

propellor (5.6.1) unstable; urgency=medium

  * fix Libvirt.hs haddock build
    Thanks, Sean Whitton

 -- Joey Hess <id@joeyh.name>  Sun, 20 Jan 2019 19:06:39 -0400

## propellor 5.10.1

=== Makefile ===
--- 
+++ 
@@ -30,8 +30,8 @@
 
 clean:
 	rm -rf dist Setup tags propellor propellor.1 privdata/local
-	find -name \*.o -exec rm {} \;
-	find -name \*.hi -exec rm {} \;
+	find . -name \*.o -exec rm {} \;
+	find . -name \*.hi -exec rm {} \;
 
 # hothasktags chokes on some template haskell etc, so ignore errors
 # duplicate tags with Propellor.Property. removed from the start, as we

=== debian/changelog ===
propellor (5.10.1-1build2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 11:17:29 +0000

propellor (5.10.1-1build1) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 12 Jan 2020 09:05:18 +0000

propellor (5.10.1-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 15 Nov 2019 11:26:38 -0700

propellor (5.10.1) unstable; urgency=medium

  [ Joey Hess ]
  * Localdir.hasOriginUrl: Depend on Git.installed.
  * Localdir.hasOriginUrl: Type changed from UnixLike to DebianLike
    because Git.installed is not implemented for other unixes.
    (API change)
  * Changed the ChrootBootstrapper type class's buildchroot method
    to take a Info parameter, instead of Maybe System.
    (The System can be extracted from the Info.)
    (API change)

  [ Sean Whitton ]
  * Chroot.{de,}bootstrapped uses the chroot's configured apt proxy and
    mirror, if these exist, when debootstrapping the chroot.
  * Rename Sbuild.useHostProxy -> Chroot.useHostProxy. (API change)

 -- Joey Hess <id@joeyh.name>  Fri, 15 Nov 2019 13:26:19 -0400

## propellor 5.10.2

=== debian/changelog ===
propellor (5.10.2-2build2) groovy; urgency=medium

  * No-change rebuild against libffi8ubuntu1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Aug 2020 00:14:20 +0000

propellor (5.10.2-2build1) groovy; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Aug 2020 15:36:32 +0200

propellor (5.10.2-2) unstable; urgency=medium

  * Rebuild the arch:all package against newer ghc (Closes: #966661).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 02 Aug 2020 15:19:15 -0700

propellor (5.10.2-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 17 May 2020 16:39:27 -0700

propellor (5.10.2) unstable; urgency=medium

  * Fix build with ghc 8.6.3.
    Thanks, Robin Munn
  * Bootstrap: Fix typo in Arch Linux dependencies.
    Thanks, Robin Munn
  * Bootstrap: Add haskell-type-errors package on Arch Linux.
    Thanks, Robin Munn
  * Apt.buildDepIn: Run build-dep command in a temporary directory,
    since it may sometimes not clean up all the files it creates.

 -- Joey Hess <id@joeyh.name>  Fri, 01 May 2020 16:47:31 -0400

## propellor 5.12

=== debian/changelog ===
propellor (5.12-1) unstable; urgency=medium

  * New upstream release.
  * Drop Makefile patch in last upload.
    Applied upstream.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 14 Sep 2020 11:55:19 -0700

propellor (5.12) unstable; urgency=medium

  * Worked around a situation where ghc uses insane amounts of memory
    displaying an error message about a property of a host having the
    wrong number of arguments.
  * Added libghc-type-errors-dev to debian/control recommends, and
    install it if available when bootstrapping propellor.
  * Borg: add UseUmask to BorgRepoOpt.
    Thanks, Nicolas Schodet
  * Borg: use "{now}" instead of $(date ...)
    Thanks, Nicolas Schodet
  * Makefile: Deal with cabal change that made sdist
    not output tarball to stdout.
    Thanks, Sean Whitton

 -- Joey Hess <id@joeyh.name>  Mon, 14 Sep 2020 12:06:46 -0400

propellor (5.11-1) unstable; urgency=medium

  * New upstream release (Closes: #969621).
  * Patch Makefile for new ./Setup losing ability to output to stdout.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 13 Sep 2020 20:47:04 -0700

propellor (5.11) unstable; urgency=medium

  * Fix display of concurrent output from processes when using
    Propellor.Property.Conductor.
    (Reversion introduced in version 5.5.0.)
  * Support bootstrapping to hosts using cabal 3.x, with new-dist directory.
  * Makefile: Fix build with cabal 3.x.
  * Borg.restored: Fix restoration, which has apparently never worked,
    at least back to borg 1.0.9.
    Thanks, Nicolas Schodet.
  * Borg.init: Added the now required encryption type parameter.
    Thanks, Nicolas Schodet.
    (API change)

 -- Joey Hess <id@joeyh.name>  Fri, 14 Aug 2020 16:02:14 -0400

=== debian/control ===
--- 
+++ 
@@ -30,6 +30,8 @@
  libghc-text-prof,
  libghc-transformers-dev,
  libghc-transformers-prof,
+ libghc-type-errors-dev,
+ libghc-type-errors-prof,
  libghc-unix-compat-dev,
  libghc-unix-compat-prof,
 Maintainer: Sean Whitton <spwhitton@spwhitton.name>
@@ -118,6 +120,7 @@
  libghc-split-dev,
  libghc-text-dev,
  libghc-transformers-dev,
+ libghc-type-errors-dev,
  libghc-unix-compat-dev,
  ${misc:Depends},
  ${shlibs:Depends},

## propellor 5.13

=== Makefile ===
CABAL?=cabal
DATE := $(shell dpkg-parsechangelog 2>/dev/null | grep Date | cut -d " " -f2-)

build: tags propellor.1 configured
	$(CABAL) build
	@if [ -d dist-newstyle ]; then \
		ln -sf $$(cabal exec -- sh -c 'command -v propellor-config') propellor; \
	else \
		ln -sf dist/build/propellor-config/propellor-config propellor; \
	fi

install:
	install -d $(DESTDIR)/usr/bin $(DESTDIR)/usr/src/propellor
	if [ -d dist-newstyle ]; then \
		install -s $$(cabal exec -- sh -c 'command -v propellor') $(DESTDIR)/usr/bin/propellor; \
	else \
		install -s dist/build/propellor/propellor $(DESTDIR)/usr/bin/propellor; \
	fi
	mkdir -p gittmp
	if [ "$(CABAL)" = ./Setup ]; then \
		./Setup sdist --output-directory=gittmp; \
	else \
		$(CABAL) sdist -o - | (cd gittmp && tar zx --strip-components=1); \
	fi
	# cabal sdist does not preserve symlinks, so copy over file
	cd gittmp && for f in $$(find -type f); do rm -f $$f; cp -a ../$$f $$f; done
	# reset mtime on files in git bundle so bundle is reproducible
	find gittmp -print0 | xargs -0r touch --no-dereference --date="$(DATE)"
	export GIT_AUTHOR_NAME=build \
	&& export GIT_AUTHOR_EMAIL=build@buildhost \
	&& export GIT_AUTHOR_DATE="$(DATE)" \
	&& export GIT_COMMITTER_NAME=build \
	&& export GIT_COMMITTER_EMAIL=build@buildhost \
	&& export GIT_COMMITTER_DATE="$(DATE)" \
	&& cd gittmp && git init \
	&& git add . \
	&& git commit -q -m "distributed version of propellor" \
	&& git bundle create $(DESTDIR)/usr/src/propellor/propellor.git master HEAD \
	&& git show-ref master --hash > $(DESTDIR)/usr/src/propellor/head
	rm -rf gittmp

clean:
	rm -rf dist dist-newstyle configured Setup \
		tags propellor propellor.1 privdata/local
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

# hothasktags chokes on some template haskell etc, so ignore errors
# duplicate tags with Propellor.Property. removed from the start, as we
# often import qualified by just the module base name.
tags:
	@find . | grep -v /.git/ | grep -v /tmp/ | grep -v dist/ | grep -v /doc/ | egrep '\.hs$$' | xargs hothasktags 2>/dev/null | perl -ne 'print; s/Propellor\.Property\.//; print' | sort > tags || true

configured: propellor.cabal
	@if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
	@$(CABAL) configure
	touch configured

propellor.1: doc/usage.mdwn doc/mdwn2man
	doc/mdwn2man propellor 1 < doc/usage.mdwn > propellor.1

.PHONY: tags

=== debian/changelog ===
propellor (5.13-3) unstable; urgency=medium

  * QA upload.
  * Move packaging repository to salsa.
  * Set Rules-Requires-Root: no.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 03 Feb 2023 13:36:11 +0100

propellor (5.13-2) unstable; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group.  (See: #990802)
  * Rebuild against ghc 9.  (Closes: #1020254)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 30 Oct 2022 20:00:50 +0100

propellor (5.13-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 16 Aug 2021 12:30:33 -0700

propellor (5.13) unstable; urgency=medium

  * Network: Added support for network interfaces with several address
    stanzas, eg ipv4 and ipv6.
    Thanks, Nicolas Schodet
  * Sudo.enabledFor: Deal with new @includedir syntax in sudoers file.
  * Apt.securityUpdates: Stop generating testing-security lines, as
    testing-security is unused per debian documentation.
  * Utility.HumanNumber: Fix rounding bug that could result in
    sometimes quite wrong values, eg "1.1 GB" when the input value was a
    few bytes less than 2 GB. Properties in Ccache and Journald that
    used it to generate config files were affected by this bug.

 -- Joey Hess <id@joeyh.name>  Fri, 30 Jul 2021 10:02:19 -0400

=== debian/control ===
--- 
+++ 
@@ -34,11 +34,12 @@
  libghc-type-errors-prof,
  libghc-unix-compat-dev,
  libghc-unix-compat-prof,
-Maintainer: Sean Whitton <spwhitton@spwhitton.name>
+Rules-Requires-Root: no
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Standards-Version: 4.1.0
 Homepage: https://propellor.branchable.com/
-Vcs-Git: https://git.spwhitton.name/propellor -b debian
-Vcs-Browser: https://git.spwhitton.name/propellor
+Vcs-Git: https://salsa.debian.org/debian/propellor.git
+Vcs-Browser: https://salsa.debian.org/debian/propellor
 X-Description: property-based host configuration management in haskell
  Propellor ensures that the system it's run in satisfies a list of
  properties, taking action as necessary when a property is not yet met.

## propellor 5.17

=== Makefile ===
--- 
+++ 
@@ -45,11 +45,8 @@
 	find . -name \*.o -exec rm {} \;
 	find . -name \*.hi -exec rm {} \;
 
-# hothasktags chokes on some template haskell etc, so ignore errors
-# duplicate tags with Propellor.Property. removed from the start, as we
-# often import qualified by just the module base name.
 tags:
-	@find . | grep -v /.git/ | grep -v /tmp/ | grep -v dist/ | grep -v /doc/ | egrep '\.hs$$' | xargs hothasktags 2>/dev/null | perl -ne 'print; s/Propellor\.Property\.//; print' | sort > tags || true
+	@hasktags . -c 2>/dev/null || true
 
 configured: propellor.cabal
 	@if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi

=== debian/changelog ===
propellor (5.17-3) unstable; urgency=medium

  * QA upload.
  * Replace CDBS with dh-sequence-haskell
  * Drop "Rules-Requires-Root: no": it is now the default
  * Bump Standards-Version to 4.7.2

  [ Andreas Beckmann ]
  * new quoting for SALSA_CI_BLHC_ARGS

 -- Alexandre Detiste <tchet@debian.org>  Thu, 23 Oct 2025 20:53:29 +0200

propellor (5.17-2) unstable; urgency=medium

  * QA upload.
  * libghc-propellor-doc: Mark as Multi-Arch: foreign.
  * Add salsa-ci.yml to ignore some blhc false positives.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Oct 2024 14:05:43 +0200

propellor (5.17-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.  (Closes: #1054640, #1053981, #1054828)
  * Clean more build artefacts.  (Closes: #1045437, #1049841)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 16 Apr 2024 19:17:26 +0200

propellor (5.17) unstable; urgency=medium

  * Apt: Enable the non-free-firmware section, when used with Debian
    bookworm or newer.

 -- Joey Hess <id@joeyh.name>  Sat, 10 Jun 2023 09:49:05 -0400

propellor (5.16) unstable; urgency=medium

  * Debootstrap: Added UseOldGpgKeyring constructor to DebootstrapConfig,
    which allows bootstrapping ancient stable releases of Debian.
  * Qemu: Install binfmt-support along with qemu-user-static.
  * Fix build with unix-2.8.0.0 and with unix-compat-0.7.

 -- Joey Hess <id@joeyh.name>  Mon, 29 May 2023 11:24:25 -0400

propellor (5.15) unstable; urgency=medium

  * Improve propellor's MetaTypes implementation to avoid an expontential
    blowup when several MetaTypes fail to unify. This should result in less
    memory use by ghc when there's a type error.
  * Avoid OOM when built by ghc 9.2.
  * Thanks to the ghc developers for their assistance, particularly spj
    and Sam Derbyshire.
  * Remove workaround to ghc using a lot of memory displaying an error
    message about a property of a host having the wrong number of
    arguments. This brings back clear error messages in such situations.

 -- Joey Hess <id@joeyh.name>  Tue, 15 Nov 2022 15:34:11 -0400

propellor (5.14) unstable; urgency=medium

  * Removed Propellor.Property.OpenID module, since the simpleid package
    got removed from Debian.
  * Renamed Linode.mlocateEnabled to Linode.locateEnabled, and made it also
    make sure plocate is enabled, if it's installed rather than mlocate.
    (API change)
  * Debootstrap.built: Stop using the deprecated qemu-debootstrap
    for bootstrapping foreign architectures. It is not needed since qemu
    2.12, which, at least on Debian, enabled the
    binfmt-support --fix-binary option.
  * Qemu.removeHostEmulationBinary: Removed this property, which is no
    longer necessary since qemu-debootstrap is not used.
    (API change)
  * Flashkernel.installed: Deal with a behavior change in flash-kernel,
    which will fail to install if is not configured first.
  * Systemd.resolvConfed is no longer enabled by default in systemd
    containers. It is probably not necessary on current systems the way it
    was back in 2014, and this avoids a problem where the host's
    /etc/resolv.conf gets overwritten when systemd is managing the
    container's /etc/resolv.conf.
  * Borg: To support borg 1.2, run borg compact to free up space after pruning.
  * Add lower bounds on async and split.
    Thanks, Simon Jakobi
  * propellor.cabal: Deduplicate exposed modules, which fixes a build
    problem with recent cabal versions.
    Thanks, Simon Jakobi

 -- Joey Hess <id@joeyh.name>  Sat, 15 Oct 2022 14:40:31 -0400

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,10 @@
 Priority: optional
 Build-Depends:
  cabal-install,
- cdbs,
- debhelper (>= 10),
+ debhelper-compat (= 13),
+ dh-sequence-haskell,
  ghc (>= 8.4.3),
  git (>= 1:2.0),
- haskell-devscripts,
  libghc-ansi-terminal-dev,
  libghc-ansi-terminal-prof,
  libghc-async-dev,
@@ -34,13 +33,12 @@
  libghc-type-errors-prof,
  libghc-unix-compat-dev,
  libghc-unix-compat-prof,
-Rules-Requires-Root: no
 Maintainer: Debian QA Group <packages@qa.debian.org>
-Standards-Version: 4.1.0
+Standards-Version: 4.7.2
 Homepage: https://propellor.branchable.com/
 Vcs-Git: https://salsa.debian.org/debian/propellor.git
 Vcs-Browser: https://salsa.debian.org/debian/propellor
-X-Description: property-based host configuration management in haskell
+Description: property-based host configuration management in haskell
  Propellor ensures that the system it's run in satisfies a list of
  properties, taking action as necessary when a property is not yet met.
  .
@@ -71,6 +69,7 @@
 
 Package: libghc-propellor-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends:
  ${haskell:Depends},

=== debian/rules ===
#!/usr/bin/make -f

# Avoid using cabal, as it writes to $HOME
export CABAL=./Setup

%:
	dh $@

execute_after_dh_auto_build:
	make propellor.1

=== debian/watch ===
# note that the tarball this watch file finds is not upstream's official release
# tarball (which does not exist)

version=3
https://hackage.haskell.org/package/propellor /package/propellor-.+/propellor-(.+).tar.gz

## propellor 5.18

=== debian/changelog ===
propellor (5.18-1) unstable; urgency=medium

  * New upstream release.
  * New maintainer. (Closes: #990802)
  * Bring back propellor source code to package:
    - This was broken with the migration from CDBS to dh-sequence-haskell.
    - Fix Makefile and remove debian/compat from cabal extra source files.
  * Add autopkgtest, doing a propellor --init.
    - Run cabal update before initializing propellor.
  * Update d/watch to version 5, use git mode and verify signature.
  * Update standards version to 4.7.3.
    - Remove now redundant Priority field from d/control.
  * Update copyright year.
  * Add bugs database to upstream metadata.
  * Explicitly disable pristine-tar in gbp.conf.
  * Add propellor-config and propellor.haddock to d/not-installed.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Sat, 14 Feb 2026 17:47:29 +0100

propellor (5.18) unstable; urgency=medium

  * Git.daemonRunning: Worked around git's unfortunate new
    requirement that safe.directory be set when running git-daemon from
    inetd.
  * Git.daemonService: New property which runs git-daemon as a systemd
    service.
  * Systemd.nspawned: Fix a bug that prevented propellor from running in
    a systemd machine due to /usr/local/propellor not being visible
    inside the machine.

 -- Joey Hess <id@joeyh.name>  Sun, 10 Aug 2025 11:24:34 -0400

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: propellor
 Section: admin
-Priority: optional
 Build-Depends:
  cabal-install,
  debhelper-compat (= 13),
@@ -33,8 +32,8 @@
  libghc-type-errors-prof,
  libghc-unix-compat-dev,
  libghc-unix-compat-prof,
-Maintainer: Debian QA Group <packages@qa.debian.org>
-Standards-Version: 4.7.2
+Maintainer: Nicolas Schodet <nico@ni.fr.eu.org>
+Standards-Version: 4.7.3
 Homepage: https://propellor.branchable.com/
 Vcs-Git: https://salsa.debian.org/debian/propellor.git
 Vcs-Browser: https://salsa.debian.org/debian/propellor

=== debian/rules ===
#!/usr/bin/make -f

export DEB_SETUP_BIN_NAME = debian/hlibrary.setup

# Avoid using cabal, as it writes to $HOME
export CABAL = $(DEB_SETUP_BIN_NAME)

%:
	dh $@

execute_after_dh_auto_build:
	make propellor.1

execute_after_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp make install-src

=== debian/tests/control ===
Tests: init
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Source: git://propellor.branchable.com/propellor
Matching-Pattern: refs/tags/@ANY_VERSION@
Mode: git
Pgp-Mode: gittag
